import { SdaBriefcaseState } from "./SdaBriefcaseState";
import { SdaWorkPackagesState } from "./SdaWorkPackagesState";
/**
 *
 */
export class SdaDialogDelegateState {
    constructor(state) {
        if (typeof state === 'string') {
            this._value = JSON.parse(state);
        }
        else {
            this._value = state;
        }
    }
    // --- State Management Helpers --- //
    // --- State Import/Export --- //
    internalValue() {
        return this._value;
    }
    copyAsJsonObject() {
        return JSON.parse(this.copyAsJsonString());
    }
    copyAsJsonString() {
        return JSON.stringify(this.internalValue());
    }
    // --- State Management --- //
    briefcaseState() {
        return new SdaBriefcaseState(this.internalValue().briefcase);
    }
    selectedWorkPackageIds() {
        return this.internalValue().selectedWorkPackageIds;
    }
    addSelectedWorkPackageId(id) {
        const index = this.internalValue().selectedWorkPackageIds.indexOf(id);
        if (index === -1) {
            this.internalValue().selectedWorkPackageIds.push(id);
        }
    }
    removeSelectedWorkPackageId(id) {
        const index = this.internalValue().selectedWorkPackageIds.indexOf(id);
        if (index > -1) {
            this.internalValue().selectedWorkPackageIds.splice(index, 1);
        }
    }
    setBriefcaseState(briefcase) {
        this.internalValue().briefcase = briefcase.internalValue();
    }
    userId() {
        return this.internalValue().userId;
    }
    setUserId(userId) {
        this.internalValue().userId = userId;
    }
    workPackagesState() {
        return new SdaWorkPackagesState(this.internalValue().workPackages);
    }
}
