export declare class Menu {
    readonly children: Menu[];
    /**
     * A special value understood by the UI, such as 'refresh'
     */
    readonly actionId: string;
    readonly directive: string;
    readonly iconUrl: string;
    readonly id: string;
    readonly label: string;
    readonly visible: boolean;
    /**
     * The menu is allowed (active) for these modes
     */
    readonly modes: string[];
    readonly type: string;
    static findSubMenu(md: Menu, matcher: (menu: Menu) => boolean): Menu;
    findAtActionId(actionId: string): Menu;
    findContextMenu(): Menu;
    findActionBarMenu(): Menu;
    readonly isPresaveDirective: boolean;
    readonly isRead: boolean;
    readonly isSeparator: boolean;
    readonly isWrite: boolean;
}
