import { BlobClientResponse } from "../client/BlobClientResponse";
import { Client } from "../client/Client";
import { ClientListener } from "../client/ClientListener";
import { JsonClientResponse } from "../client/JsonClientResponse";
import { TextClientResponse } from "../client/TextClientResponse";
import { VoidClientResponse } from "../client/VoidClientResponse";
import { StreamProducer } from '../io/StreamProducer';
import { CvLocale } from "../util";
import { StringDictionary } from '../util/StringDictionary';
export declare class DialogProxy implements Client {
    private _clientListener;
    private _dialogDelegateChain;
    private _initialized;
    private _initializedPr;
    private _initializedRejectFn;
    private _initializedResolveFn;
    private _lastActivity;
    private _locale;
    constructor();
    clientListener(): ClientListener;
    addClientListener(clientListener: ClientListener, locale: CvLocale): void;
    removeClientListener(clientListener: ClientListener): void;
    isAnyUserInBriefcaseMode(tenantId: string): Promise<boolean>;
    isUserInBriefcaseMode(userInfo: {}): Promise<boolean>;
    readonly lastActivity: Date;
    getBlob(baseUrl: string, resourcePath?: string): Promise<BlobClientResponse>;
    getText(baseUrl: string, resourcePath?: string): Promise<TextClientResponse>;
    openStream(baseUrl: string, resourcePath?: string): Promise<StreamProducer>;
    postMultipart(baseUrl: string, resourcePath: string, formData: FormData): Promise<VoidClientResponse>;
    getJson(baseUrl: string, resourcePath?: string, queryParams?: StringDictionary): Promise<JsonClientResponse>;
    postJson(baseUrl: string, resourcePath: string, jsonBody?: StringDictionary): Promise<JsonClientResponse>;
    putJson(baseUrl: string, resourcePath: string, jsonBody?: StringDictionary): Promise<JsonClientResponse>;
    deleteJson(baseUrl: string, resourcePath: string): Promise<JsonClientResponse>;
    private static delegateRequest(previousPr, delegateIterator, requestFn, args);
    private prepareForActivity();
    private processRequestAndResponse(requestFn, responseFn, args);
}
